From 0605ba49843f353e7bab6022ef3b7094f0967164 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 10 2017 18:12:49 +0000
Subject: [PATCH 793/1001] Implement the General Settings panel


---

diff --git a/hubs/static/client/app/core/HubConfig.jsx b/hubs/static/client/app/core/HubConfig.jsx
index dcc54d5..9040e46 100644
--- a/hubs/static/client/app/core/HubConfig.jsx
+++ b/hubs/static/client/app/core/HubConfig.jsx
@@ -4,7 +4,11 @@ import {
   defineMessages,
   FormattedMessage,
   } from 'react-intl';
-import {ChatPanel, NotImplementedPanel} from './HubConfigPanel.jsx';
+import {
+  GeneralPanel,
+  ChatPanel,
+  NotImplementedPanel,
+  } from './HubConfigPanel.jsx';
 import TabSet from '../components/TabSet.jsx';
 
 
@@ -155,8 +159,11 @@ export default class HubConfig extends React.Component {
                     tabListClass="col-md-3"
                     tabContentClass="col-md-9"
                     >
-                    <NotImplementedPanel
+                    <GeneralPanel
+                      hubConfig={this.state.hubConfig}
+                      generalConfig={this.state.generalConfig}
                       tabTitle={<FormattedMessage {...messages.general} />}
+                      handleChange={this.handleChange}
                       />
                     <NotImplementedPanel
                       tabTitle={<FormattedMessage {...messages.owners} />}
diff --git a/hubs/static/client/app/core/HubConfigPanel.jsx b/hubs/static/client/app/core/HubConfigPanel.jsx
index 920b184..4990dd3 100644
--- a/hubs/static/client/app/core/HubConfigPanel.jsx
+++ b/hubs/static/client/app/core/HubConfigPanel.jsx
@@ -8,6 +8,26 @@ import TabPanel from '../components/TabPanel.jsx';
 
 
 const messages = defineMessages({
+  general_title: {
+    id: "hubs.core.config.general.title",
+    defaultMessage: "General Settings",
+  },
+  general_intro: {
+    id: "hubs.core.config.general.intro",
+    defaultMessage: "Change your global hub parameters here.",
+  },
+  general_summary: {
+    id: "hubs.core.config.general.summary",
+    defaultMessage: "Summary",
+  },
+  general_left_width: {
+    id: "hubs.core.config.general.left_width",
+    defaultMessage: "Left width",
+  },
+  general_avatar: {
+    id: "hubs.core.config.general.avatar",
+    defaultMessage: "Avatar",
+  },
   chat_title: {
     id: "hubs.core.config.chat.title",
     defaultMessage: "Chat Settings",
@@ -47,18 +67,72 @@ export class NotImplementedPanel extends React.Component {
 
 }
 
+
+export class GeneralPanel extends React.Component {
+
+  render() {
+    var stillLoading = (typeof this.props.hubConfig.summary === "undefined");
+    return (
+      <div>
+        <FormattedMessage {...messages.general_title} tagName="h3" />
+        <FormattedMessage {...messages.general_intro} tagName="p" />
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-summary">
+            <FormattedMessage {...messages.general_summary} />
+          </label>
+          <input
+            type="text" className="form-control" name="summary"
+            id="hub-settings-general-summary"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.summary}
+            />
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-leftwidth">
+            <FormattedMessage {...messages.general_left_width} />
+          </label>
+          <input
+            type="number" className="form-control" name="left_width"
+            id="hub-settings-general-leftwidth"
+            disabled={stillLoading}
+            min="1" max="11"
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.left_width}
+            />
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-avatar">
+            <FormattedMessage {...messages.general_avatar} />
+          </label>
+          <input
+            type="text" className="form-control" name="avatar"
+            id="hub-settings-general-avatar"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.avatar}
+            />
+        </div>
+      </div>
+    );
+  }
+
+}
+
+
 export class ChatPanel extends React.Component {
 
   render() {
     var networks = [],
         channel = "#",
-        //stillLoading = (typeof this.props.hubConfig.chat_channel === "undefined");
         stillLoading = (
-          typeof this.props.generalConfig.chat_networks === "undefined"
-          );
+          typeof this.props.hubConfig.chat_channel === "undefined"
+        );
+
     if (this.props.hubConfig.chat_channel) {
       channel = "#" + this.props.hubConfig.chat_channel.replace(/^#*/, "");
     }
+
     if (this.props.generalConfig.chat_networks) {
       networks = this.props.generalConfig.chat_networks.map(
         function(network, index) {
@@ -70,6 +144,7 @@ export class ChatPanel extends React.Component {
         }.bind(this)
       );
     }
+
     return (
       <div>
         <FormattedMessage {...messages.chat_title} tagName="h3" />
